/*
 *  GLG impiccato.cpp
 *  Progetto scuola
 *	VERSIONE GENERALE COMPATIBILE
 * 	Versione 0.5.9
 *  Created by Giulio Fieramosca on 08/08/10.
 *  Copyright 2010 GLG Programs. All rights reserved.
 *
 */
// Dichiarazione delle librerie
#include "iostream"
#include "fstream"
#include "string.h"
#include "time.h"
#include "stdlib.h"
using namespace std;

#define maxwords 60448	// Numero delle parole contenute nel file vocabolario
#define alfabeto 26	// Numero massimo delle lettere della tastiera
#define max_tentativi 8	// Numero massimo di tentativi
// Funzione che stampa le lettere o gli spazi, e che stabilisce se una parola è stata
// completamente indovinata
bool stampa_lettere(char lettere[alfabeto], char parola[30], char lettera_ins, int lunghezza, int& esatte);
void draw_hangman(int);	// Disegna l'impiccato con caratteri ASCII

fstream file;	// Variabile per la lettura dello stream dal file vocabolario 

int main()
{
	char percorso[40]="./vocab_IT.diz";	// Percorso del file che contiene le parole
	char s;	// Carattere per le scelte
	srand((unsigned int) time((time_t*)NULL));	// Inizializza numeri casuali
	
	do
	{
		printf("\033[2J");
		char parola[30];	// Stringa che contiene la parola random
							// da indovinare del dizionario
		char lettere[alfabeto]; // Vettore che contiene le lettere gia inserite
		long int rand_word; // Numero parola a caso da leggere nel file dizionario
		
		rand_word=rand()%(maxwords+1);	// Scrittura di un valore random da 0 a maxwords compresi
		file.open(percorso, ios::in);	// Apertura file in lettura
		if(!file)	{cout<<"File dizionario " << percorso << " non presente!!!" << endl;	exit(1);}
		for(int z=0;z<rand_word;z++)	// Ciclo per leggere la parola n° rand_word dal file
		{
			file >> parola;
		}
		file.close();
		
		short int lunghezza=strlen(parola);	// Lunghezza della parola random
		cout << "La parola e' di " << lunghezza << " lettere" << endl;	// stampa su schermo la lunghezza
		for(int x=0; x<lunghezza;x++)	cout << "_";	// Stampa su schermo "lunghezza" spazi
		cout << endl;	// Va a capo
		draw_hangman(0);	// Disegna l'omino dicendo che non è stato effettuato nessun tentativo (0)
		
		for (int tentativi=0;tentativi<alfabeto;tentativi++) lettere[tentativi]=NULL;	//azzera lettere
		int contatore=0; // Variabile per gestire le lettere gia inserite a ogni giro del ciclo for
		for (int tentativi=0; tentativi<max_tentativi;)
		{
			char lettera_ins=NULL;
			
			//cout << tentativi<< lunghezza << contatore<<  endl;
			//cout << "tentativi = " << max_tentativi-tentativi << endl;
			//cout << "tentativo numero " << tentativi <<endl;
			//stampa_lettere(lettere, parola, lunghezza);
			/*
			for (int z=0; z<lunghezza;z++)	//controlla se inserire _ o la lettera
			{
				valore=0;
				for(int k=0;k<alfabeto;k++)
				{
					if (lettere[k]==parola[z])	{	cout << parola[z]; valore=1;	break;	}
				}
				if (valore==0)	cout << "_";
			}
			cout << endl;*/
			
			while(1){
                cout << "Inserisci una lettera, inserisci |\nper vedere le lettere gia' inserite: ";
				cin >> lettera_ins;	// Salva la lettera inserite
				cout << endl;
				if (lettera_ins=='|'){	// Inserendo | è possibile vedere le lettere gia inserite
				    cout << "Lettere gia' inserite: ";
					for(int k=0;k<contatore;k++) cout << lettere[k];
					cout << endl << endl;
					continue;
				}

				bool inserita=0; // Per controllare se una lettera è gia stata inserita
				for(int k=0; k<alfabeto;k++)
				{
					if (lettera_ins==lettere[k])	{	cout << "Lettera gia inserita" << endl << endl; inserita=1; continue; }
				}
				if (inserita==0)	{lettere[contatore]=lettera_ins;	contatore++;	break;}
			}

			int esatte=0;
			
			/*valore=0;	//vecchio ciclo incorporato
			for (int z=0; z<lunghezza;z++)
			{
				//cout << "Lettera inserita= "<<lettera_ins << "parola[z]=" << parola[z]<< "[]" << z << endl;
				if (parola[z]==lettera_ins)	valore=1;
				for(int k=0;k<alfabeto;k++)
				{
					if (lettere[k]==parola[z])	{esatte++; 	break;}
				}
			}
			//cout <<"valore"<< valore << endl;*/
			printf("\033[2J");
			cout << "La parola e' di " << lunghezza << " lettere" << endl;	// Ristampa la lunghezza della parola per il prossimo tentativo
			// Chiamata della funzione stampa_lettere, che stampa le lettere e restituisce 0 se è una lettera non presente
			// 1 se è presente, se è 0 incrementa i tentativi usati
			if(stampa_lettere(lettere, parola, lettera_ins, lunghezza, esatte)==0)	tentativi++;
			draw_hangman(tentativi);	// Disegna l'impiccato
			
			// Se le lettere giuste sono uguali alle lettere totali stampa "Hai vinto"
			if (esatte==lunghezza){	cout << endl <<"--------------" << endl << "|Hai vinto!!!|"<<endl << "--------------" << endl; break;}//12
			// Se i tentativi sono uguali ai tentativi massimi stampa "Hai perso"
			if(tentativi==max_tentativi)	cout << endl <<"--------------" << endl << "|Hai perso!!!|"<<endl << "--------------" << endl;;
		}
		// Stampa la parola e chiede se riprovare
		cout << "La parola era: " << parola << endl << endl;
		cout << "Ancora?" << endl;
		cin>>s;
		cout << endl << endl;
	}
	while (s=='s');
}

bool stampa_lettere(char lettere[alfabeto], char parola[30], char lettera_ins, int lunghezza, int& esatte)
{
	bool lettera_presente=0;	// Valore che controlla se la lettera appena inserita è presente o no
	for (int z=0; z<lunghezza;z++)
			{
				bool controllo=0;	// Controlla se inserire lo spazio o la lettera
				if (parola[z]==lettera_ins)	lettera_presente=1;	// Se la parola contiene la lettera inserita da 1
				for(int k=0;k<alfabeto;k++)	// Stampa spazi e lettere
				{
					if (lettere[k]==parola[z])	{	cout << parola[z]; controllo=1; esatte++;	break;	}
				}
				if (controllo==0)	cout << "_";
			}
			cout << endl;
			//cout << lettera_presente << endl;
			return lettera_presente;
}
/*
 * Impiccato:
 * _____
 * |/  |
 * |   O
 * |  /|\
 * |   |
 * |  / \
 * |_______
 **/
void draw_hangman(int tentativi)
{
	switch (tentativi){
		case 0: cout << "      " << endl << "|     " << endl << "|     " << endl << "|      " << endl << "|     " << endl << "|      " << endl << "|_____" << endl<< endl; break;
		case 1: cout << "      " << endl << "|/    " << endl << "|     " << endl << "|      " << endl << "|     " << endl << "|      " << endl << "|_____" << endl<< endl; break;
		case 2: cout << "______" << endl << "|/    " << endl << "|     " << endl << "|      " << endl << "|     " << endl << "|      " << endl << "|_____" << endl<< endl; break;
		case 3: cout << "______" << endl << "|/   |" << endl << "|     " << endl << "|      " << endl << "|     " << endl << "|      " << endl << "|_____" << endl<< endl; break;
		case 4: cout << "______" << endl << "|/   |" << endl << "|    O" << endl << "|      " << endl << "|     " << endl << "|      " << endl << "|_____" << endl<< endl; break;
		case 5: cout << "______" << endl << "|/   |" << endl << "|    O" << endl << "|    | " << endl << "|     " << endl << "|      " << endl << "|_____" << endl<< endl; break;
		case 6: cout << "______" << endl << "|/   |" << endl << "|    O" << endl << "|   /|\\" << endl << "|     " << endl << "|      " << endl << "|_____" << endl<< endl; break;
		case 7: cout << "______" << endl << "|/   |" << endl << "|    O" << endl << "|   /|\\" << endl << "|    |" << endl << "|      " << endl << "|_____" << endl<< endl; break;
        case 8: cout << "______" << endl << "|/   |" << endl << "|    O" << endl << "|   /|\\" << endl << "|    |" << endl << "|   / \\" << endl << "|_____" << endl<< endl; break;
	}
}
